#include <Servo.h> //include Servo library

const int RForward = 180; 
const int RBackward = RForward * -1; 
const int LForward = RBackward; 
const int LBackward = RForward; 
const int RNeutral = 102; 
const int LNeutral = 103; //constants for motor speed
const int irPin = 0;  //Sharp infrared sensor pin
int rightDistance; //distance away from obstacles on the right
int leftDistance;  //distance away from obstacles on the left
const int dangerThresh = 250; //threshold for obstacles
Servo irMotor;  
Servo leftMotor;
Servo rightMotor; //declare motors

void setup()
{
  rightMotor.attach(9);
  leftMotor.attach(11);
  irMotor.attach(6); //attach motors to proper pins
  irMotor.write(90); //set IR sensor pan to center
}

void loop()
{
  int val = analogRead(irPin); //read IR sensor
  if (val<dangerThresh) //if path is clear
  {
    leftMotor.write(LForward); 
    rightMotor.write(RForward); //move forward
  }
  else //if path is blocked
  {
    leftMotor.write(LNeutral);
    rightMotor.write(RNeutral); 
    irMotor.write(180); 
    delay(100);
    rightDistance = analogRead(irPin); //scan to the right
    delay(500);
    irMotor.write(0);
    delay(700);
    leftDistance = analogRead(irPin); //scan to the left
    delay(500);
    irMotor.write(90); //return to center
    delay(100);
    compareDistance();
  }
}
  
void compareDistance()
{
  if (leftDistance<rightDistance) //if left is less obstructed 
  {
    leftMotor.write(LBackward); 
    rightMotor.write(RForward); //turn left
    delay(1000); 
  }
  else if (rightDistance<leftDistance) //if right is less obstructed
  {
    leftMotor.write(LForward);
    rightMotor.write(RBackward); //turn right
    delay(1000);
  }
   else //if they are equally obstructed
  {
    leftMotor.write(LForward); 
    rightMotor.write(RBackward); //turn 180 degrees
    delay(2000);
  }
}


  

